#include "dirent.h"

#include "stdlib.h"
#include "string.h"

#include <gpdef.h>
#include <gpstdio.h>

#include "log.h"

int isDir(const char *inName)
{
	if (!inName)
		return 0;

	if (strcmp(inName, "gp:\\") == 0)
		return 1;

        GPFILEATTR atrib;
        int result = GpFileAttr(inName, &atrib);
	if (result != SM_OK)
		return 0;
	return ((atrib.attr&0x10)==0x10);
}

DIR * opendir(const char *inName)
{
	DIR * dir = 0;
	ulong num = 0;

	// First, ask the SDK if it exists
	if (GpDirEnumNum(inName, &num) != SM_OK)
	{
		Aprint("DirEnumFailed:%s %d\n", inName, num);
		return 0;
	}

	// File?
	if (!isDir(inName))
		return 0;

	// If so then create a structure and copy relevent info in...
	dir = malloc(sizeof(DIR));
	dir->pos = 0;

	num = strlen(inName);
	dir->name = (char *)malloc(num);
	
	strcpy(dir->name, inName);

	dir->magic = DIRMAGIC;

	return dir;
}

int closedir(DIR * dir) //0->suc, -1->fail
{
	if (!dir || (dir->magic!=DIRMAGIC))
		return -1;
	
	dir->magic = 0;
	free(dir->name);
	free(dir);

	return 0;
}

struct dirent * readdir(DIR * dir)
{
	static dirent sDirent;
	GPDIRENTRY entries[1];
	ulong read;

	if (!dir || (dir->magic!=DIRMAGIC))
		return 0;

	if (GpDirEnumList(dir->name, dir->pos++, 1, entries, &read) != SM_OK)
		return 0;

	if (read != 1)
		return 0;

	strcpy(sDirent.d_name,entries[0].name);

	return &sDirent;
}

void getcwd(char * dir, int maxLen)
{
	if (maxLen < 200)
		return;

	GpRelativePathGet(dir);
}

